/*======================================================================*/
/* Proxy kernel linker script                                           */
/*======================================================================*/
/* This is the linker script used when building the proxy kernel. */

/*----------------------------------------------------------------------*/
/* Setup                                                                */
/*----------------------------------------------------------------------*/

/* The OUTPUT_ARCH command specifies the machine architecture where the
   argument is one of the names used in the BFD library. More
   specifically one of the entires in bfd/cpu-mips.c */

OUTPUT_ARCH( "riscv" )
ENTRY(_start)

/*----------------------------------------------------------------------*/
/* Sections                                                             */
/*----------------------------------------------------------------------*/

SECTIONS
{

 /* . = 0x80001000; */
 /* .tohost ALIGN(0x1000) : { *(.tohost) } */

  . = 0x20000;
  .keyStore ALIGN(0) : { *(.data.pkStore) *(.data.skStore) *(.data.ctx) }

  . = 0x00 + TOHOST_BASE;	
  
  .tohost ALIGN(0x0000) : { *(.tohost) } 
  
  /* text: test code section */
  . = 0x01000000;
  .text.init : { *(.text.init) }


  .text : { *(.text) }

  /* data segment */
  .data : { *(.data) }

  .sdata : {
    __global_pointer$ = . + 0x800;
    *(.srodata.cst16) *(.srodata.cst8) *(.srodata.cst4) *(.srodata.cst2) *(.srodata*)
    *(.sdata .sdata.* .gnu.linkonce.s.*)
  }

  /* bss segment */
  .sbss : {
    *(.sbss .sbss.* .gnu.linkonce.sb.*)
    *(.scommon)
  }
  .bss : { *(.bss) }

  /* thread-local data segment */
  .tdata :
  {
    _tls_data = .;
    *(.tdata.begin)
    *(.tdata)
    *(.tdata.end)
  }
  .tbss :
  {
    *(.tbss)
    *(.tbss.end)
  }

  /* End of uninitalized data segement */
  _end = .;
  __control_fuses__ = ADDR( .rodata.control_fuses );
  __version_fuse__ = ADDR( .rodata.version_fuse );
  __fuse__ = ADDR( .rodata.fuse );
  __mk__ = ADDR( .rodata.mk );
  __secvt__ = sec_vector_table;
}

